<?php
class ControllerExtensionShippingBaikalsr extends Controller{

private $error = array();	

public function install() {
	$this->load->model('extension/shipping/baikalsr');
	$this->model_extension_shipping_baikalsr->install();
}

public function uninstall() {
	$this->load->model('extension/shipping/baikalsr');
	$this->model_extension_shipping_baikalsr->uninstall();
}

public function index(){
	$this->load->model('setting/setting');	
	$this->load->model('extension/shipping/baikalsr');
	$this->load->library('baikalsrtools');
			
	$this->load->language("/extension/shipping/baikalsr");
	
	$this->document->setTitle($this->language->get('heading_title'));
	
	$data['breadcrumbs'] = array();
	$data['breadcrumbs'][] = array(
		'text' => $this->language->get('text_extension'),
		'href' => $this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=shipping', true)
	);

	$data['breadcrumbs'][] = array(
		'text' => $this->language->get('heading_title'),
		'href' => $this->url->link('extension/shipping/baikalsr', 'user_token=' . $this->session->data['user_token'], true)
	);
	$data['settings'] = $this->url->link('extension/shipping/baikalsr/settings', 'user_token=' . $this->session->data['user_token'], true);	
	$data['cancel'] = $this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=shipping', true);
	$data['url_list'] = html_entity_decode($this->url->link('extension/shipping/baikalsr', 'user_token=' . $this->session->data['user_token'], true), ENT_QUOTES, 'UTF-8');	
	$data['url_track'] = html_entity_decode($this->url->link('extension/shipping/baikalsr/tracking', 'user_token=' . $this->session->data['user_token'], true), ENT_QUOTES, 'UTF-8');	
	$data['url_popup'] = html_entity_decode($this->url->link('extension/shipping/baikalsr/popup_shipping', 'user_token=' . $this->session->data['user_token'], true), ENT_QUOTES, 'UTF-8');	
	
	if (isset($this->request->get['filter_order_id'])) {
		$filter_order_id = $this->request->get['filter_order_id'];
	} else {
		$filter_order_id = '';
	}
	
	if (isset($this->request->get['filter_customer'])) {
		$filter_customer = $this->request->get['filter_customer'];
	} else {
		$filter_customer = '';
	}
	
	if (isset($this->request->get['filter_shipping_city'])) {
		$filter_shipping_city = $this->request->get['filter_shipping_city'];
	} else {
		$filter_shipping_city = '';
	}
	
	if (isset($this->request->get['filter_shipping_id'])) {
		$filter_shipping_id = $this->request->get['filter_shipping_id'];
	} else {
		$filter_shipping_id = '';
	}
	
	if (isset($this->request->get['sort'])) {
		$sort = $this->request->get['sort'];
	} else {
		$sort = 'o.order_id';
	}

	if (isset($this->request->get['order'])) {
		$order = $this->request->get['order'];
	} else {
		$order = 'DESC';
	}
	
	if (isset($this->request->get['page'])) {
		$page = $this->request->get['page'];
	} else {
		$page = 1;
	}

	$url = '';	
	
	if (isset($this->request->get['filter_order_id'])) {
		$url .= '&filter_order_id=' . $this->request->get['filter_order_id'];
	}
	
	if (isset($this->request->get['filter_customer'])) {
		$url .= '&filter_customer=' . urlencode(html_entity_decode($this->request->get['filter_customer'], ENT_QUOTES, 'UTF-8'));
	}

	if (isset($this->request->get['filter_shipping_city'])) {
		$url .= '&filter_shipping_city=' . urlencode(html_entity_decode($this->request->get['filter_shipping_city'], ENT_QUOTES, 'UTF-8'));
	}

	if (isset($this->request->get['filter_shipping_id'])) {
		$url .= '&filter_shipping_id=' . $this->request->get['filter_shipping_id'];
	}
		
	if (isset($this->request->get['sort'])) {
		$url .= '&sort=' . $this->request->get['sort'];
	}

	if (isset($this->request->get['order'])) {
		$url .= '&order=' . $this->request->get['order'];
	}

	if (isset($this->request->get['page'])) {
		$url .= '&page=' . $this->request->get['page'];
	}
		
	$data['orders'] = array();
		
	$filter_data = array(
		'filter_order_id'        => $filter_order_id,
		'filter_shipping_id'     => $filter_shipping_id,
		'filter_customer'	     => $filter_customer,
		'filter_shipping_city'   => $filter_shipping_city,
		'sort'                   => $sort,
		'order'                  => $order,
		'start'                  => ($page - 1) * $this->config->get('config_limit_admin'),
		'limit'                  => $this->config->get('config_limit_admin')
	);
	
	$order_total = $this->model_extension_shipping_baikalsr->getTotalOrders($filter_data);
	
	$results = $this->model_extension_shipping_baikalsr->getOrders($filter_data);
	foreach ($results as $result) {		
		$data['orders'][] = array(
			'order_id'             => $result['order_id'],
			'customer'        	   => $result['customer'],
			'shipping_city'        => $result['shipping_city'],			
			'shipping_id'          => $result['shipping_id'],
			'shipping_method'      => $result['shipping_method'],
			'shipping_code'        => $result['shipping_code'],
			'shipping_status_name' => $result['shipping_status_name'] ? $result['shipping_status_name'] : $this->language->get('text_status_missing'),
			'new_shipping_cost'    => $result['new_shipping_cost']>0 && $result['shipping_cost'] != $result['new_shipping_cost'] ? $this->currency->format($result['new_shipping_cost'], $result['currency_code'], $result['currency_value']) : '',
			'shipping_cost'        => $this->currency->format($result['shipping_cost'], $result['currency_code'], $result['currency_value']),
			'total'                => $this->currency->format($result['total'], $result['currency_code'], $result['currency_value']),
			'date_added'           => date($this->language->get('date_format_short'), strtotime($result['date_added'])),
			'date_modified'        => date($this->language->get('date_format_short'), strtotime($result['date_modified'])),
			//'view'            => $this->url->link('sale/order/info', 'user_token=' . $this->session->data['user_token'] . '&order_id=' . $result['order_id'] . $url, true),
			//'edit'            => $this->url->link('sale/order/edit', 'user_token=' . $this->session->data['user_token'] . '&order_id=' . $result['order_id'] . $url, true)
		);
	}
	
	$data['user_token'] = $this->session->data['user_token'];
	
	if (isset($this->error['warning'])) {
		$data['error_warning'] = $this->error['warning'];
	} else {
		$data['error_warning'] = '';
	}
	
	$url = '';

	if (isset($this->request->get['filter_order_id'])) {
		$url .= '&filter_order_id=' . $this->request->get['filter_order_id'];
	}

	if (isset($this->request->get['filter_customer'])) {
		$url .= '&filter_customer=' . urlencode(html_entity_decode($this->request->get['filter_customer'], ENT_QUOTES, 'UTF-8'));
	}

	if (isset($this->request->get['filter_shipping_city'])) {
		$url .= '&filter_shipping_city=' . urlencode(html_entity_decode($this->request->get['filter_shipping_city'], ENT_QUOTES, 'UTF-8'));
	}
	
	if (isset($this->request->get['filter_shipping_id'])) {
		$url .= '&filter_shipping_id=' . $this->request->get['filter_shipping_id'];
	}

	if ($order == 'ASC') {
		$url .= '&order=DESC';
	} else {
		$url .= '&order=ASC';
	}

	if (isset($this->request->get['page'])) {
		$url .= '&page=' . $this->request->get['page'];
	}

	$data['sort_order'] = $this->url->link('extension/shipping/baikalsr', 'user_token=' . $this->session->data['user_token'] . '&sort=o.order_id' . $url, true);
	$data['sort_date_added'] = $this->url->link('extension/shipping/baikalsr', 'user_token=' . $this->session->data['user_token'] . '&sort=o.date_added' . $url, true);
	$data['sort_customer'] = $this->url->link('extension/shipping/baikalsr', 'user_token=' . $this->session->data['user_token'] . '&sort=customer' . $url, true);
	$data['sort_shipping_city'] = $this->url->link('extension/shipping/baikalsr', 'user_token=' . $this->session->data['user_token'] . '&sort=o.shipping_city' . $url, true);
	$data['sort_shipping_id'] = $this->url->link('extension/shipping/baikalsr', 'user_token=' . $this->session->data['user_token'] . '&sort=os.shipping_id' . $url, true);
	$data['sort_shipping_code'] = $this->url->link('extension/shipping/baikalsr', 'user_token=' . $this->session->data['user_token'] . '&sort=o.shipping_code' . $url, true);
	$data['sort_shipping_cost'] = $this->url->link('extension/shipping/baikalsr', 'user_token=' . $this->session->data['user_token'] . '&sort=shipping_cost' . $url, true);
	$data['sort_total'] = $this->url->link('extension/shipping/baikalsr', 'user_token=' . $this->session->data['user_token'] . '&sort=o.total' . $url, true);

	$url = '';

	if (isset($this->request->get['filter_order_id'])) {
		$url .= '&filter_order_id=' . $this->request->get['filter_order_id'];
	}

	if (isset($this->request->get['filter_customer'])) {
		$url .= '&filter_customer=' . urlencode(html_entity_decode($this->request->get['filter_customer'], ENT_QUOTES, 'UTF-8'));
	}

	if (isset($this->request->get['filter_shipping_city'])) {
		$url .= '&filter_shipping_city=' . urlencode(html_entity_decode($this->request->get['filter_shipping_city'], ENT_QUOTES, 'UTF-8'));
	}
	
	if (isset($this->request->get['filter_shipping_id'])) {
		$url .= '&filter_shipping_id=' . $this->request->get['filter_shipping_id'];
	}

	if (isset($this->request->get['sort'])) {
		$url .= '&sort=' . $this->request->get['sort'];
	}

	if (isset($this->request->get['order'])) {
		$url .= '&order=' . $this->request->get['order'];
	}
		
	$pagination = new Pagination();
	$pagination->total = $order_total;
	$pagination->page = $page;
	$pagination->limit = $this->config->get('config_limit_admin');
	$pagination->url = $this->url->link('extension/shipping/baikalsr', 'user_token=' . $this->session->data['user_token'] . $url . '&page={page}', true);

	$data['pagination'] = $pagination->render();	
	
	$data['results'] = sprintf($this->language->get('text_pagination'), ($order_total) ? (($page - 1) * $this->config->get('config_limit_admin')) + 1 : 0, ((($page - 1) * $this->config->get('config_limit_admin')) > ($order_total - $this->config->get('config_limit_admin'))) ? $order_total : ((($page - 1) * $this->config->get('config_limit_admin')) + $this->config->get('config_limit_admin')), $order_total, ceil($order_total / $this->config->get('config_limit_admin')));
		
	$data['filter_order_id'] = $filter_order_id;
	$data['filter_customer'] = $filter_customer;
	$data['filter_shipping_city'] = $filter_shipping_city;
	$data['filter_shipping_id'] = $filter_shipping_id;

	$data['sort'] = $sort;
	$data['order'] = $order;	
		
	$data['header'] = $this->load->controller('common/header');
	$data['column_left'] = $this->load->controller('common/column_left');
	$data['footer'] = $this->load->controller('common/footer');		
	
	$this->response->setOutput($this->load->view('extension/shipping/baikalsr', $data));	
}

public function settings(){
	
	$this->load->model('setting/setting');	
	$this->load->library('baikalsrtools');
	$this->load->language("/extension/shipping/baikalsr");
	
	$this->document->setTitle($this->language->get('settings_title'));
	
	if (($this->request->server['REQUEST_METHOD'] == 'POST')){ //&& $this->validate()) {
		$this->model_setting_setting->editSetting('shipping_baikalsr', $this->request->post);

		$this->session->data['success'] = $this->language->get('text_success');

		$this->response->redirect($this->url->link('extension/shipping/baikalsr', 'user_token=' . $this->session->data['user_token'], true));
	}

	if (isset($this->error['warning'])) {
		$data['error_warning'] = $this->error['warning'];
	} else {
		$data['error_warning'] = '';
	}

	if (isset($this->error['code'])) {
		$data['error_code'] = $this->error['code'];
	} else {
		$data['error_code'] = '';
	}

	$data['breadcrumbs'] = array();
	$data['breadcrumbs'][] = array(
		'text' => $this->language->get('text_extension'),
		'href' => $this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=shipping', true)
	);

	$data['breadcrumbs'][] = array(
		'text' => $this->language->get('heading_title'),
		'href' => $this->url->link('extension/shipping/baikalsr', 'user_token=' . $this->session->data['user_token'], true)
	);
	
	$data['breadcrumbs'][] = array(
		'text' => $this->language->get('settings_title'),
		'href' => $this->url->link('extension/shipping/baikalsr/settings', 'user_token=' . $this->session->data['user_token'], true)
	);
	
	$data['action'] = $this->url->link('extension/shipping/baikalsr/settings', 'user_token=' . $this->session->data['user_token'], true);
	$data['cancel'] = $this->url->link('extension/shipping/baikalsr', 'user_token=' . $this->session->data['user_token'], true);
	$data['url_cities'] = html_entity_decode($this->url->link('extension/shipping/baikalsr/fias_cities', 'user_token=' . $this->session->data['user_token'], true), ENT_QUOTES, 'UTF-8');
	$data['url_streets'] = html_entity_decode($this->url->link('extension/shipping/baikalsr/fias_streets', 'user_token=' . $this->session->data['user_token'], true), ENT_QUOTES, 'UTF-8');
	$data['url_houses'] = html_entity_decode($this->url->link('extension/shipping/baikalsr/fias_houses', 'user_token=' . $this->session->data['user_token'], true), ENT_QUOTES, 'UTF-8');
	$data['url_contragents'] = html_entity_decode($this->url->link('extension/shipping/baikalsr/contragent_list', 'user_token=' . $this->session->data['user_token'], true), ENT_QUOTES, 'UTF-8');
	$data['url_cargotypes'] = html_entity_decode($this->url->link('extension/shipping/baikalsr/cargoTypes_list', 'user_token=' . $this->session->data['user_token'], true), ENT_QUOTES, 'UTF-8');	
	$data['url_terminals'] = html_entity_decode($this->url->link('extension/shipping/baikalsr/terminals_list', 'user_token=' . $this->session->data['user_token'], true), ENT_QUOTES, 'UTF-8');
	
	$this->load->model('extension/shipping/baikalsr');	
	 
	if (isset($this->request->post['shipping_baikalsr_status'])) {
		$data['shipping_baikalsr_status'] = $this->request->post['shipping_baikalsr_status'];
	} else {
		$data['shipping_baikalsr_status'] = $this->config->get('shipping_baikalsr_status');
	}
	if (isset($this->request->post['shipping_baikalsr_geo_zone_id'])) {
		$data['shipping_baikalsr_geo_zone_id'] = $this->request->post['shipping_baikalsr_geo_zone_id'];
	} else {
		$data['shipping_baikalsr_geo_zone_id'] = $this->config->get('shipping_baikalsr_geo_zone_id');
	}
	$this->load->model('localisation/geo_zone');
	$data['geo_zones'] = $this->model_localisation_geo_zone->getGeoZones();		
	if (isset($this->request->post['shipping_baikalsr_sort_order'])) {
		$data['shipping_baikalsr_sort_order'] = $this->request->post['shipping_baikalsr_sort_order'];
	} else {
		$data['shipping_baikalsr_sort_order'] = $this->config->get('shipping_baikalsr_sort_order');
	}
	if (isset($this->request->post['shipping_baikalsr_authkey'])) {
		$data['shipping_baikalsr_authkey'] = $this->request->post['shipping_baikalsr_authkey'];
	} else {
		$data['shipping_baikalsr_authkey'] = $this->config->get('shipping_baikalsr_authkey');
	}	
	if (isset($this->request->post['shipping_baikalsr_authkeytest'])) {
		$data['shipping_baikalsr_authkeytest'] = $this->request->post['shipping_baikalsr_authkeytest'];
	} else {
		$data['shipping_baikalsr_authkeytest'] = $this->config->get('shipping_baikalsr_authkeytest');
	}	
	if (isset($this->request->post['shipping_baikalsr_test'])) {
		$data['shipping_baikalsr_test'] = $this->request->post['shipping_baikalsr_test'];
	} else {
		$data['shipping_baikalsr_test'] = $this->config->get('shipping_baikalsr_test');
	}	
	$data['consignor_contragents'] = $this->model_extension_shipping_baikalsr->getContragents();
	if (isset($this->request->post['shipping_baikalsr_consignor_contragent_id'])) {
		$data['shipping_baikalsr_consignor_contragent_id'] = $this->request->post['shipping_baikalsr_consignor_contragent_id'];
	} else {
		$data['shipping_baikalsr_consignor_contragent_id'] = $this->config->get('shipping_baikalsr_consignor_contragent_id');
	}	
	if (isset($this->request->post['shipping_baikalsr_consignor_fio'])) {
		$data['shipping_baikalsr_consignor_fio'] = $this->request->post['shipping_baikalsr_consignor_fio'];
	} else {
		$data['shipping_baikalsr_consignor_fio'] = $this->config->get('shipping_baikalsr_consignor_fio');
	}	
	if (isset($this->request->post['shipping_baikalsr_consignor_phone'])) {
		$data['shipping_baikalsr_consignor_phone'] = $this->request->post['shipping_baikalsr_consignor_phone'];
	} else {
		$data['shipping_baikalsr_consignor_phone'] = $this->config->get('shipping_baikalsr_consignor_phone');
	}		
	if (isset($this->request->post['shipping_baikalsr_consignor_email'])) {
		$data['shipping_baikalsr_consignor_email'] = $this->request->post['shipping_baikalsr_consignor_email'];
	} else {
		$data['shipping_baikalsr_consignor_email'] = $this->config->get('shipping_baikalsr_consignor_email');
	}
	if (isset($this->request->post['shipping_baikalsr_departure_guid'])) {
		$data['shipping_baikalsr_departure_guid'] = $this->request->post['shipping_baikalsr_departure_guid'];
	} else {
		$data['shipping_baikalsr_departure_guid'] = $this->config->get('shipping_baikalsr_departure_guid');
	}
	if (isset($this->request->post['shipping_baikalsr_departure'])) {
		$data['shipping_baikalsr_departure'] = $this->request->post['shipping_baikalsr_departure'];
	} else {
		$data['shipping_baikalsr_departure'] = $this->config->get('shipping_baikalsr_departure');
	}		
	if (isset($this->request->post['shipping_baikalsr_departure_from_address'])) {
		$data['shipping_baikalsr_departure_from_address'] = $this->request->post['shipping_baikalsr_departure_from_address'];
	} else {
		$data['shipping_baikalsr_departure_from_address'] = $this->config->get('shipping_baikalsr_departure_from_address');
	}
	$data['departure_terminals'] = $this->model_extension_shipping_baikalsr->getTerminals($data['shipping_baikalsr_departure_guid'], "start");
	if (isset($this->request->post['shipping_baikalsr_departure_terminal_id'])) {
		$data['shipping_baikalsr_departure_terminal_id'] = $this->request->post['shipping_baikalsr_departure_terminal_id'];
	} else {
		$data['shipping_baikalsr_departure_terminal_id'] = $this->config->get('shipping_baikalsr_departure_terminal_id');
	}
	if (isset($this->request->post['shipping_baikalsr_departure_street_guid'])) {
		$data['shipping_baikalsr_departure_street_guid'] = $this->request->post['shipping_baikalsr_departure_street_guid'];
	} else {
		$data['shipping_baikalsr_departure_street_guid'] = $this->config->get('shipping_baikalsr_departure_street_guid');
	}
	if (isset($this->request->post['shipping_baikalsr_departure_street'])) {
		$data['shipping_baikalsr_departure_street'] = $this->request->post['shipping_baikalsr_departure_street'];
	} else {
		$data['shipping_baikalsr_departure_street'] = $this->config->get('shipping_baikalsr_departure_street');
	}
	if (isset($this->request->post['shipping_baikalsr_departure_house_guid'])) {
		$data['shipping_baikalsr_departure_house_guid'] = $this->request->post['shipping_baikalsr_departure_house_guid'];
	} else {
		$data['shipping_baikalsr_departure_house_guid'] = $this->config->get('shipping_baikalsr_departure_house_guid');
	}
	if (isset($this->request->post['shipping_baikalsr_departure_house'])) {
		$data['shipping_baikalsr_departure_house'] = $this->request->post['shipping_baikalsr_departure_house'];
	} else {
		$data['shipping_baikalsr_departure_house'] = $this->config->get('shipping_baikalsr_departure_house');
	}
	if (isset($this->request->post['shipping_baikalsr_departure_housing'])) {
		$data['shipping_baikalsr_departure_housing'] = $this->request->post['shipping_baikalsr_departure_housing'];
	} else {
		$data['shipping_baikalsr_departure_housing'] = $this->config->get('shipping_baikalsr_departure_housing');
	}
	if (isset($this->request->post['shipping_baikalsr_departure_building'])) {
		$data['shipping_baikalsr_departure_building'] = $this->request->post['shipping_baikalsr_departure_building'];
	} else {
		$data['shipping_baikalsr_departure_building'] = $this->config->get('shipping_baikalsr_departure_building');
	}
	if (isset($this->request->post['shipping_baikalsr_departure_apartment'])) {
		$data['shipping_baikalsr_departure_apartment'] = $this->request->post['shipping_baikalsr_departure_apartment'];
	} else {
		$data['shipping_baikalsr_departure_apartment'] = $this->config->get('shipping_baikalsr_departure_apartment');
	}
	if (isset($this->request->post['shipping_baikalsr_departure_comment'])) {
		$data['shipping_baikalsr_departure_comment'] = $this->request->post['shipping_baikalsr_departure_comment'];
	} else {
		$data['shipping_baikalsr_departure_comment'] = $this->config->get('shipping_baikalsr_departure_comment');
	}
	if (isset($this->request->post['shipping_baikalsr_departure_prr'])) {
		$data['shipping_baikalsr_departure_prr'] = $this->request->post['shipping_baikalsr_departure_prr'];
	} else {
		$data['shipping_baikalsr_departure_prr'] = $this->config->get('shipping_baikalsr_departure_prr');
	}
	if (isset($this->request->post['shipping_baikalsr_departure_floor'])) {
		$data['shipping_baikalsr_departure_floor'] = $this->request->post['shipping_baikalsr_departure_floor'];
	} else {
		$data['shipping_baikalsr_departure_floor'] = $this->config->get('shipping_baikalsr_departure_floor');
	}
	if (isset($this->request->post['shipping_baikalsr_departure_lift'])) {
		$data['shipping_baikalsr_departure_lift'] = $this->request->post['shipping_baikalsr_departure_lift'];
	} else {
		$data['shipping_baikalsr_departure_lift'] = $this->config->get('shipping_baikalsr_departure_lift');
	}
	$data['cargo_types'] = $this->baikalsrtools->getCargoTypes();	
	if (isset($this->request->post['shipping_baikalsr_cargotype_id'])) {
		$data['shipping_baikalsr_cargotype_id'] = $this->request->post['shipping_baikalsr_cargotype_id'];
	} else {
		$data['shipping_baikalsr_cargotype_id'] = $this->config->get('shipping_baikalsr_cargotype_id');
	}		
	if (isset($this->request->post['shipping_baikalsr_packing'])) {
		$data['shipping_baikalsr_packing'] = $this->request->post['shipping_baikalsr_packing'];
	} else {
		$data['shipping_baikalsr_packing'] = $this->config->get('shipping_baikalsr_packing');
	}		
	if (isset($this->request->post['shipping_baikalsr_length'])) {
		$data['shipping_baikalsr_length'] = $this->request->post['shipping_baikalsr_length'];
	} else {
		$data['shipping_baikalsr_length'] = $this->config->get('shipping_baikalsr_length');
	}		
	if (isset($this->request->post['shipping_baikalsr_width'])) {
		$data['shipping_baikalsr_width'] = $this->request->post['shipping_baikalsr_width'];
	} else {
		$data['shipping_baikalsr_width'] = $this->config->get('shipping_baikalsr_width');
	}	
	if (isset($this->request->post['shipping_baikalsr_height'])) {
		$data['shipping_baikalsr_height'] = $this->request->post['shipping_baikalsr_height'];
	} else {
		$data['shipping_baikalsr_height'] = $this->config->get('shipping_baikalsr_height');
	}	
	$this->load->model('localisation/length_class');
	$data['length_classes'] = $this->model_localisation_length_class->getLengthClasses();
	if (isset($this->request->post['shipping_baikalsr_length_class_id'])) {
		$data['shipping_baikalsr_length_class_id'] = $this->request->post['shipping_baikalsr_length_class_id'];
	} else {
		$data['shipping_baikalsr_length_class_id'] = $this->config->get('shipping_baikalsr_length_class_id');
	}	
	if (isset($this->request->post['shipping_baikalsr_weight'])) {
		$data['shipping_baikalsr_weight'] = $this->request->post['shipping_baikalsr_weight'];
	} else {
		$data['shipping_baikalsr_weight'] = $this->config->get('shipping_baikalsr_weight');
	}
	$this->load->model('localisation/weight_class');
	$data['weight_classes'] = $this->model_localisation_weight_class->getWeightClasses();
	if (isset($this->request->post['shipping_baikalsr_weight_class_id'])) {
		$data['shipping_baikalsr_weight_class_id'] = $this->request->post['shipping_baikalsr_weight_class_id'];
	} else {
		$data['shipping_baikalsr_weight_class_id'] = $this->config->get('shipping_baikalsr_weight_class_id');
	}	
	if (isset($this->request->post['shipping_baikalsr_default_for_item'])) {
		$data['shipping_baikalsr_default_for_item'] = $this->request->post['shipping_baikalsr_default_for_item'];
	} else {
		$data['shipping_baikalsr_default_for_item'] = $this->config->get('shipping_baikalsr_default_for_item');
	}

	$data['user_token'] = $this->session->data['user_token'];

	$data['header'] = $this->load->controller('common/header');
	$data['column_left'] = $this->load->controller('common/column_left');
	$data['footer'] = $this->load->controller('common/footer');

	$this->response->setOutput($this->load->view('extension/shipping/baikalsr_settings', $data));	
}

public function tracking() {
	$this->load->library('baikalsrtools');
	$this->load->model('sale/order');
	$this->load->model('extension/shipping/baikalsr');
	$this->load->language("/extension/shipping/baikalsr");
	
	$json = array(
		'shipping_id' => '',
		'status_id' => '',
		'status_name' => '',
		'shipping_cost' => '',		
		'success' => false,
	);
	
	$order_id = $this->request->post['order_id'];
	$order_info = $this->model_sale_order->getOrder($order_id);	
	if ($order_info !== NULL) {	
		$shipment = $this->model_extension_shipping_baikalsr->getShipmentOrder($order_id);
		if(isset($shipment["shipping_id"]) && !empty($shipment["shipping_id"])){
			$json['shipping_id'] = $shipment["shipping_id"];
			//Request status
			$baikalResponse = $this->baikalsrtools->getOrderData($shipment["shipping_id"]);
			if (isset($baikalResponse["status"]["id"])) {
				$shipment['status_id'] = $baikalResponse["status"]["id"];
				$json['status_id'] = $shipment["status_id"];
			}else{
				$json['error'] = $this->language->get('error_api_no_response');
			}
			if (isset($baikalResponse["status"]["name"]) && !empty($baikalResponse["status"]["name"])) {
				$shipment['status_name'] = $baikalResponse["status"]["name"];
				$json['status_name'] = $shipment["status_name"];
			}else{
				$json['error'] = $this->language->get('error_api_no_response');
			}	
			if (isset($baikalResponse["total"]["sum"]) && !empty($baikalResponse["total"]["sum"])) {
				$totals = $this->model_sale_order->getOrderTotals($order_id);		
				$shipping_cost = 0;
				foreach ($totals as $total) {
					if ($total['code'] == 'shipping') {
						$shipping_cost = $total['value'];
					}
				}
				$json['shipping_cost'] = $this->currency->format($shipping_cost, $order_info['currency_code'], $order_info['currency_value']);
				if($shipping_cost != $baikalResponse["total"]["sum"]){
					$json['new_shipping_cost'] = $this->currency->format($baikalResponse["total"]["sum"], $order_info['currency_code'], $order_info['currency_value']);				
				}
				$shipment['shipping_cost'] = $baikalResponse["total"]["sum"];
			}else{
				$json['error'] = $this->language->get('error_api_no_response');
			}
			if (!isset($json['error'])) {		
				$this->model_extension_shipping_baikalsr->updateShipmentOrder($shipment);
				$json['success'] = true;
			}
		}else{
			$json['error'] = $this->language->get('error_no_shipping_yet');
		}
	}
	$this->response->addHeader('Content-Type: application/json');
	$this->response->setOutput(json_encode($json));
}

public function popup_shipping() {
	$json = array(
		'body' => '',
		'title' => '',
		'success' => false,
		'required_fields' => [],
		'success_message' => ''
	);

	$this->load->language("/extension/shipping/baikalsr");
	$this->load->library('baikalsrtools');
	$this->load->model('extension/shipping/baikalsr');
	$this->load->model('catalog/product');
	$this->load->model('sale/order');

	$form_data = NULL;
	$order_id = $this->request->post['order_id'];
	$order_info = $this->model_sale_order->getOrder($order_id);	
	if ($order_info !== NULL) {	
	
		$json['title'] = $this->language->get('text_popup_title_single').$order_id;
		
		$shipment = $this->model_extension_shipping_baikalsr->getShipmentOrder($order_id);
		
		if(isset($shipment["shipping_id"]) && !empty($shipment["shipping_id"])){	
			$data['disabled'] = true;
		}	
		
		if(isset($shipment["data"]) && !empty($shipment["data"])){	
			$form_data = $shipment["data"];
		}
		
		if ($this->request->post['action'] == 'submit') {			
			if(isset($shipment["shipping_id"]) && !empty($shipment["shipping_id"])){	
				$json['success'] = true;
			}else{
				$form_data = $this->prepareData($this->request->post['form']);
				//Create shipping request
				if($this->validateForm($form_data)){
					$baikalResponse = $this->baikalsrtools->order(array_merge($form_data, ['order_id' => $order_id]));
					$apiErrors = [];
					if(empty($baikalResponse)) {
						$apiErrors[] = $this->language->get('error_api_no_response');
					}elseif(isset($baikalResponse["errors"]) && !empty($baikalResponse["errors"])) {	
						foreach($baikalResponse["errors"] as $id => $value) {
							$apiErrors[] = $value["description"];
						}
					}elseif(!isset($baikalResponse["request_hash"]) || empty($baikalResponse["request_hash"])){
						$apiErrors[] = $this->language->get('error_api_no_hash');
					}elseif(!isset($baikalResponse["request_id"]) || empty($baikalResponse["request_id"])){
						$apiErrors[] = $this->language->get('error_api_no_request');
					}elseif(!isset($baikalResponse["tracknumbers"]) || empty($baikalResponse["tracknumbers"])){
						$apiErrors[] = $this->language->get('error_api_no_tracking');
					}
					if(empty($apiErrors)){
						$shipment['id'] = isset($shipment['id']) ? $shipment['id'] : NULL;
						$shipment['order_id'] = $order_id;
						$shipment['data'] = $form_data;
						$shipment['shipping_id'] = $baikalResponse["request_id"];
						$shipment['hash'] = $baikalResponse["request_hash"];
						$shipment['tracking_number'] = $baikalResponse["tracknumbers"][0];
						$shipment['status_id'] = '0';
						$shipment['status_name'] = $this->language->get('text_status_0'); 
						$shipment['message'] = ''; 
						$shipment['shipping_cost'] = $form_data['shipping_cost'];
						$this->model_extension_shipping_baikalsr->updateShipmentOrder($shipment);							
						
						$json['success'] = true;						
					}else{
						if (!isset($this->error['danger']) && !empty($apiErrors)) {
							$this->error['danger'] = $this->language->get('error_api').': '. implode(" ", $apiErrors);
						}
					}
				}
			}			
		}		
		
		if (!empty($this->error['danger'])) {
			$data['error'] = $this->error['danger'];
		} else {
			$data['error'] = '';
		}
		
		if (!empty($this->error['warning'])) {
			$data['warning'] = $this->error['warning'];
		} else {
			$data['warning'] = '';
		}	
		
		if (isset($this->error['consignor_contragent'])) {
			$data['error_consignor_contragent'] = $this->error['consignor_contragent'];
		} else {
			$data['error_consignor_contragent'] = '';
		}

		if (isset($this->error['consignor_fio'])) {
			$data['error_consignor_fio'] = $this->error['consignor_fio'];
		} else {
			$data['error_consignor_fio'] = '';
		}
		if (isset($this->error['consignor_phone'])) {
			$data['error_consignor_phone'] = $this->error['consignor_phone'];
		} else {
			$data['error_consignor_phone'] = '';
		}
		if (isset($this->error['consignor_email'])) {
			$data['error_consignor_email'] = $this->error['consignor_email'];
		} else {
			$data['error_consignor_email'] = '';
		}
		if (isset($this->error['consignee_company'])) {
			$data['error_consignee_company'] = $this->error['consignee_company'];
		} else {
			$data['error_consignee_company'] = '';
		}
		if (isset($this->error['consignee_legal_opf'])) {
			$data['error_consignee_legal_opf'] = $this->error['consignee_legal_opf'];
		} else {
			$data['error_consignee_legal_opf'] = '';
		}
		if (isset($this->error['consignee_inn_kpp'])) {
			$data['error_consignee_inn_kpp'] = $this->error['consignee_inn_kpp'];			
		} else {
			$data['error_consignee_inn_kpp'] = '';
		}
		if (isset($this->error['consignee_fio'])) {
			$data['error_consignee_fio'] = $this->error['consignee_fio'];			
		} else {
			$data['error_consignee_fio'] = '';
		}
		if (isset($this->error['consignee_physical_document'])) {
			$data['error_consignee_physical_document'] = $this->error['consignee_physical_document'];	
		} else {
			$data['error_consignee_physical_document'] = '';
		}
		if (isset($this->error['consignee_seria_number'])) {
			$data['error_consignee_seria_number'] = $this->error['consignee_seria_number'];					
		} else {
			$data['error_consignee_seria_number'] = '';
		}
		if (isset($this->error['consignee_phone'])) {
			$data['error_consignee_phone'] = $this->error['consignee_phone'];
		} else {
			$data['error_consignee_phone'] = '';
		}
		if (isset($this->error['consignee_email'])) {
			$data['error_consignee_email'] = $this->error['consignee_email'];
		} else {
			$data['error_consignee_email'] = '';
		}
		if (isset($this->error['departure'])) {
			$data['error_departure'] = $this->error['departure'];
		} else {
			$data['error_departure'] = '';
		}
		if (isset($this->error['departure_terminal'])) {
			$data['error_departure_terminal'] = $this->error['departure_terminal'];					
		} else {
			$data['error_departure_terminal'] = '';
		}
		if (isset($this->error['departure_street'])) {
			$data['error_departure_street'] = $this->error['departure_street'];		
		} else {
			$data['error_departure_street'] = '';
		}
		if (isset($this->error['departure_house'])) {
			$data['error_departure_house'] = $this->error['departure_house'];	
		} else {
			$data['error_departure_house'] = '';
		}
		if (isset($this->error['departure_floor'])) {
			$data['error_departure_floor'] = $this->error['departure_floor'];	
		} else {
			$data['error_departure_floor'] = '';
		}
		if (isset($this->error['destination'])) {
			$data['error_destination'] = $this->error['destination'];
		} else {
			$data['error_destination'] = '';
		}
		if (isset($this->error['destination_terminal'])) {
			$data['error_destination_terminal'] = $this->error['destination_terminal'];					
		} else {
			$data['error_destination_terminal'] = '';
		}
		if (isset($this->error['destination_street'])) {
			$data['error_destination_street'] = $this->error['destination_street'];		
		} else {
			$data['error_destination_street'] = '';
		}
		if (isset($this->error['destination_house'])) {
			$data['error_destination_house'] = $this->error['destination_house'];		
		} else {
			$data['error_destination_house'] = '';
		}
		if (isset($this->error['destination_floor'])) {
			$data['error_destination_floor'] = $this->error['destination_floor'];	
		} else {
			$data['error_destination_floor'] = '';
		}
		if (isset($this->error['cargotype'])) {
			$data['error_cargotype'] = $this->error['cargotype'];			
		} else {
			$data['error_cargotype'] = '';
		}
		if (isset($this->error['volume'])) {
			$data['error_volume'] = $this->error['volume'];		
		} else {
			$data['error_volume'] = '';
		}
		if (isset($this->error['weight'])) {
			$data['error_weight'] = $this->error['weight'];					
		} else {
			$data['error_weight'] = '';
		}
		
		$data['url_cities'] = html_entity_decode($this->url->link('extension/shipping/baikalsr/fias_cities', 'user_token=' . $this->session->data['user_token'], true), ENT_QUOTES, 'UTF-8');
		$data['url_streets'] = html_entity_decode($this->url->link('extension/shipping/baikalsr/fias_streets', 'user_token=' . $this->session->data['user_token'], true), ENT_QUOTES, 'UTF-8');
		$data['url_houses'] = html_entity_decode($this->url->link('extension/shipping/baikalsr/fias_houses', 'user_token=' . $this->session->data['user_token'], true), ENT_QUOTES, 'UTF-8');
		$data['url_terminals'] = html_entity_decode($this->url->link('extension/shipping/baikalsr/terminals_list', 'user_token=' . $this->session->data['user_token'], true), ENT_QUOTES, 'UTF-8');
		
		$data['order_id'] = $order_id;
		
		$data['order_href'] = $this->url->link('sale/order/info', 'user_token=' . $this->session->data['user_token'] . '&order_id=' . $order_id, true);
		
		//Consignor
		$data['consignor_contragents'] = $this->model_extension_shipping_baikalsr->getContragents();
		if (isset($form_data['consignor_contragent_id'])) {
			$data['shipping_baikalsr_consignor_contragent_id'] = $form_data['consignor_contragent_id'];
		} else {
			$data['shipping_baikalsr_consignor_contragent_id'] = $this->config->get('shipping_baikalsr_consignor_contragent_id');
		}	
		if (isset($form_data['consignor_fio'])) {
			$data['shipping_baikalsr_consignor_fio'] = $form_data['consignor_fio'];
		} else {
			$data['shipping_baikalsr_consignor_fio'] = $this->config->get('shipping_baikalsr_consignor_fio');
		}	
		$consignor_fio = explode(' ', $data["shipping_baikalsr_consignor_fio"]);
		if (isset($form_data['author_lastname'])) {
			$data['shipping_baikalsr_author_lastname'] = $form_data['author_lastname'];
		} else {
			if(isset($consignor_fio[0]) && !empty($consignor_fio[0]))
				$data['shipping_baikalsr_author_lastname'] = $consignor_fio[0];			
			else
				$data['shipping_baikalsr_author_lastname'] = '';
		}		
		if (isset($form_data['author_firstname'])) {
			$data['shipping_baikalsr_author_firstname'] = $form_data['author_firstname'];
		} else {
			if(isset($consignor_fio[1]) && !empty($consignor_fio[1]))
				$data['shipping_baikalsr_author_firstname'] = $consignor_fio[1];			
			else
				$data['shipping_baikalsr_author_firstname'] = '';
		}
		if (isset($form_data['author_middlename'])) {
			$data['shipping_baikalsr_author_middlename'] = $form_data['author_middlename'];
		} else {
			if(isset($consignor_fio[2]) && !empty($consignor_fio[2]))
				$data['shipping_baikalsr_author_middlename'] = $consignor_fio[2];			
			else
				$data['shipping_baikalsr_author_middlename'] = '';
		}				
		if (isset($form_data['consignor_phone'])) {
			$data['shipping_baikalsr_consignor_phone'] = $form_data['consignor_phone'];
		} else {
			$data['shipping_baikalsr_consignor_phone'] = $this->config->get('shipping_baikalsr_consignor_phone');
		}		
		if (isset($form_data['consignor_email'])) {
			$data['shipping_baikalsr_consignor_email'] = $form_data['consignor_email'];
		} else {
			$data['shipping_baikalsr_consignor_email'] = $this->config->get('shipping_baikalsr_consignor_email');
		}
		//Consignee
		if (isset($form_data['consignee_physical_person'])) {
			$data['shipping_baikalsr_consignee_physical_person'] = $form_data['consignee_physical_person'];
		} else {
			if (isset($order_info['shipping_company']) && !empty($order_info['shipping_company'])) {
				$data['shipping_baikalsr_consignee_physical_person'] = false;
			}else{
				$data['shipping_baikalsr_consignee_physical_person'] = true;
			}
		}	
		if (isset($form_data['consignee_company'])) {
			$data['shipping_baikalsr_consignee_company'] = $form_data['consignee_company'];
		} else {
			$data['shipping_baikalsr_consignee_company'] = $order_info['shipping_company'];
		}
		if (isset($form_data['consignee_inn_kpp'])) {
			$data['shipping_baikalsr_consignee_inn_kpp'] = $form_data['consignee_inn_kpp'];
		} else {
			$data['shipping_baikalsr_consignee_inn_kpp'] = '';
		}	
		$consignee_inn_kpp = explode(' ', $data["shipping_baikalsr_consignee_inn_kpp"], 2);
		if (isset($form_data['consignee_inn'])) {
			$data['shipping_baikalsr_consignee_inn'] = $form_data['consignee_inn'];
		} else {
			if(isset($consignee_inn_kpp[0]) && !empty($consignee_inn_kpp[0]))
				$data['shipping_baikalsr_consignee_inn'] = $consignee_inn_kpp[0];			
			else
				$data['shipping_baikalsr_consignee_inn'] = '';
		}	
		if (isset($form_data['consignee_kpp'])) {
			$data['shipping_baikalsr_consignee_kpp'] = $form_data['consignee_kpp'];
		} else {
			if(isset($consignee_inn_kpp[1]) && !empty($consignee_inn_kpp[1]))
				$data['shipping_baikalsr_consignee_kpp'] = $consignee_inn_kpp[1];			
			else
				$data['shipping_baikalsr_consignee_kpp'] = '';
		}		
		if (isset($form_data['consignee_fio'])) {
			$data['shipping_baikalsr_consignee_fio'] = $form_data['consignee_fio'];
		} else {
			$data['shipping_baikalsr_consignee_fio'] = '';
			if(isset($order_info['lastname']) && !empty($order_info['lastname']))
				$data['shipping_baikalsr_consignee_fio'] .= $order_info['lastname'];
			if(isset($order_info['firstname']) && !empty($order_info['firstname']))
				$data['shipping_baikalsr_consignee_fio'] .= ' ' . $order_info['firstname'];	
			if(isset($order_info['custom_field']) && !empty($order_info['custom_field'])){
				// Custom Fields
				$this->load->model('customer/custom_field');
				foreach ($order_info['custom_field'] as $fieldID => $fieldVal) {
					$custom_field = $this->model_customer_custom_field->getCustomField($fieldID);
					if($custom_field['name'] == 'Отчество' || $custom_field['name'] == 'Middle name' || $custom_field['name'] == 'Middlename')
						$data['shipping_baikalsr_consignee_fio'] .= ' ' . $fieldVal;		
				}
			}
			$data['shipping_baikalsr_consignee_fio'] = trim($data['shipping_baikalsr_consignee_fio']);
		}
		$contragent_opf = $this->model_extension_shipping_baikalsr->getOpf();
		$data['contragent_legal_opf'] = [];
		foreach ($contragent_opf as $opf) {
			if($opf["legalForm"] == 1)
				$data['contragent_legal_opf'][] = $opf;				
		}		
		if (isset($form_data['consignee_legal_opf_id'])) {
			$data['shipping_baikalsr_consignee_legal_opf_id'] = $form_data['consignee_legal_opf_id'];
		} else {
			$data['shipping_baikalsr_consignee_legal_opf_id'] = 4;
		}
		$data['contragent_physical_document'] = [];
		foreach ($contragent_opf as $opf) {
			if($opf["legalForm"] == 2)
				$data['contragent_physical_document'][] = $opf;					
		}		
		if (isset($form_data['consignee_physical_document_id'])) {
			$data['shipping_baikalsr_consignee_physical_document_id'] = $form_data['consignee_physical_document_id'];
		} else {
			$data['shipping_baikalsr_consignee_physical_document_id'] = 1;
		}					
		if (!isset($form_data['consignee_no_document'])) {
			$data['shipping_baikalsr_consignee_no_document'] = false;	
		} else {
			$data['shipping_baikalsr_consignee_no_document'] = $form_data['consignee_no_document'];
		}
		if (isset($form_data['consignee_seria_number'])) {
			$data['shipping_baikalsr_consignee_seria_number'] = $form_data['consignee_seria_number'];
		} else {
			$data['shipping_baikalsr_consignee_seria_number'] = '';
		}
		$consignee_seria_number = explode(' ', $data["shipping_baikalsr_consignee_seria_number"], 2);
		if (isset($form_data['consignee_seria'])) {
			$data['shipping_baikalsr_consignee_seria'] = $form_data['consignee_seria'];
		} else {
			if(isset($consignee_seria_number[0]) && !empty($consignee_seria_number[0]))
				$data['shipping_baikalsr_consignee_seria'] = $consignee_seria_number[0];			
			else
				$data['shipping_baikalsr_consignee_seria'] = '';
		}	
		if (isset($form_data['consignee_number'])) {
			$data['shipping_baikalsr_consignee_number'] = $form_data['consignee_number'];
		} else {
			if(isset($consignee_seria_number[1]) && !empty($consignee_seria_number[1]))
				$data['shipping_baikalsr_consignee_number'] = $consignee_seria_number[1];			
			else
				$data['shipping_baikalsr_consignee_number'] = '';
		}		
		if (isset($form_data['consignee_phone'])) {
			$data['shipping_baikalsr_consignee_phone'] = $form_data['consignee_phone'];
		} else {
			$data['shipping_baikalsr_consignee_phone'] = $order_info['telephone'];
		}
		if (isset($form_data['consignee_email'])) {
			$data['shipping_baikalsr_consignee_email'] = $form_data['consignee_email'];
		} else {
			$data['shipping_baikalsr_consignee_email'] = $order_info['email'];
		}		
		if (isset($form_data['departure_guid'])) {
			$data['shipping_baikalsr_departure_guid'] = $form_data['departure_guid'];
		} else {
			$data['shipping_baikalsr_departure_guid'] = $this->config->get('shipping_baikalsr_departure_guid');
		}
		if (isset($form_data['departure'])) {
			$data['shipping_baikalsr_departure'] = $form_data['departure'];
		} else {
			$data['shipping_baikalsr_departure'] = $this->config->get('shipping_baikalsr_departure');
		}		
		if (isset($form_data['departure_from_address'])) {
			$data['shipping_baikalsr_departure_from_address'] = $form_data['departure_from_address'];
		} else {
			$data['shipping_baikalsr_departure_from_address'] = $this->config->get('shipping_baikalsr_departure_from_address');
		}
		$data['departure_terminals'] = $this->model_extension_shipping_baikalsr->getTerminals($data['shipping_baikalsr_departure_guid'], "start");
		if (isset($form_data['departure_terminal_id'])) {
			$data['shipping_baikalsr_departure_terminal_id'] = $form_data['departure_terminal_id'];
		} else {
			$data['shipping_baikalsr_departure_terminal_id'] = $this->config->get('shipping_baikalsr_departure_terminal_id');
		}
		if (isset($form_data['departure_street_guid'])) {
			$data['shipping_baikalsr_departure_street_guid'] = $form_data['departure_street_guid'];
		} else {
			$data['shipping_baikalsr_departure_street_guid'] = $this->config->get('shipping_baikalsr_departure_street_guid');
		}
		if (isset($form_data['departure_street'])) {
			$data['shipping_baikalsr_departure_street'] = $form_data['departure_street'];
		} else {
			$data['shipping_baikalsr_departure_street'] = $this->config->get('shipping_baikalsr_departure_street');
		}
		if (isset($form_data['departure_house_guid'])) {
			$data['shipping_baikalsr_departure_house_guid'] = $form_data['departure_house_guid'];
		} else {
			$data['shipping_baikalsr_departure_house_guid'] = $this->config->get('shipping_baikalsr_departure_house_guid');
		}
		if (isset($form_data['departure_house'])) {
			$data['shipping_baikalsr_departure_house'] = $form_data['departure_house'];
		} else {
			$data['shipping_baikalsr_departure_house'] = $this->config->get('shipping_baikalsr_departure_house');
		}
		if (isset($form_data['departure_housing'])) {
			$data['shipping_baikalsr_departure_housing'] = $form_data['departure_housing'];
		} else {
			$data['shipping_baikalsr_departure_housing'] = $this->config->get('shipping_baikalsr_departure_housing');
		}
		if (isset($form_data['departure_building'])) {
			$data['shipping_baikalsr_departure_building'] = $form_data['departure_building'];
		} else {
			$data['shipping_baikalsr_departure_building'] = $this->config->get('shipping_baikalsr_departure_building');
		}
		if (isset($form_data['departure_apartment'])) {
			$data['shipping_baikalsr_departure_apartment'] = $form_data['departure_apartment'];
		} else {
			$data['shipping_baikalsr_departure_apartment'] = $this->config->get('shipping_baikalsr_departure_apartment');
		}
		if (isset($form_data['departure_comment'])) {
			$data['shipping_baikalsr_departure_comment'] = $form_data['departure_comment'];
		} else {
			$data['shipping_baikalsr_departure_comment'] = $this->config->get('shipping_baikalsr_departure_comment');
		}
		if (isset($form_data['departure_prr'])) {
			$data['shipping_baikalsr_departure_prr'] = $form_data['departure_prr'];
		} else {
			$data['shipping_baikalsr_departure_prr'] = $this->config->get('shipping_baikalsr_departure_prr');
		}
		if (isset($form_data['departure_floor'])) {
			$data['shipping_baikalsr_departure_floor'] = $form_data['departure_floor'];
		} else {
			$data['shipping_baikalsr_departure_floor'] = $this->config->get('shipping_baikalsr_departure_floor');
		}
		if (isset($form_data['departure_lift'])) {
			$data['shipping_baikalsr_departure_lift'] = $form_data['departure_lift'];
		} else {
			$data['shipping_baikalsr_departure_lift'] = $this->config->get('shipping_baikalsr_departure_lift');
		}
		if (isset($form_data['destination_guid'])) {
			$data['shipping_baikalsr_destination_guid'] = $form_data['destination_guid'];
		} else {
			$data['shipping_baikalsr_destination_guid'] = '';
		}
		if (isset($form_data['destination'])) {
			$data['shipping_baikalsr_destination'] = $form_data['destination'];
		} else {
			$data['shipping_baikalsr_destination'] = $order_info['shipping_city'] . ' ' . $order_info['shipping_zone'];
		}			
		if (isset($form_data['destination_to_address'])) {
			$data['shipping_baikalsr_destination_to_address'] = $form_data['destination_to_address'];
		} else {
			if($order_info['shipping_code']=='baikalsr.baikalsr')			
				$data['shipping_baikalsr_destination_to_address'] = true;
			else
				$data['shipping_baikalsr_destination_to_address'] = false;
		}
		if (isset($form_data['destination_guid']) && !empty($form_data['destination_guid'])) {
			$data['destination_terminals'] = $this->model_extension_shipping_baikalsr->getTerminals($form_data['destination_guid'], "finish");
		}else{
			$data['destination_terminals'] = [];
			$arCity = [];
			if(!empty($order_info['shipping_city'])){
				$arCity = $this->baikalsrtools->getCityByName($order_info['shipping_city']);
			}	
			if(empty($arCity) && !empty($order_info['shipping_zone'])){
				$arCity = $this->baikalsrtools->getCityByName($this->baikalsrtools->untranslit($order_info['shipping_zone']));
			}
			if(!empty($arCity) && isset($arCity['guid'])) {
				$data['destination_terminals'] = $this->model_extension_shipping_baikalsr->getTerminals($arCity['affiliate']['guid'] ? $arCity['affiliate']['guid'] : $arCity['guid'], "finish");
			}
		}
		if (isset($form_data['destination_terminal_id'])) {
			$data['shipping_baikalsr_destination_terminal_id'] = $form_data['destination_terminal_id'];
		} else {
			$data['shipping_baikalsr_destination_terminal_id'] = -1;
			$sessionData = $this->model_extension_shipping_baikalsr->getSessionDataByIP($order_info['ip']);
			if(isset($sessionData['shipping_baikalsr_destination_terminal_id']) && !empty($sessionData['shipping_baikalsr_destination_terminal_id']))
				$data['shipping_baikalsr_destination_terminal_id'] = $sessionData['shipping_baikalsr_destination_terminal_id'];
		}
		if(!in_array($data['shipping_baikalsr_destination_terminal_id'], array_column($data['destination_terminals'], 'id')))
			$data['shipping_baikalsr_destination_terminal_id'] = -1;
		if (isset($form_data['destination_street_guid'])) {
			$data['shipping_baikalsr_destination_street_guid'] = $form_data['destination_street_guid'];
		} else {
			$data['shipping_baikalsr_destination_street_guid'] = '';
		}	
		if (isset($form_data['destination_street'])) {
			$data['shipping_baikalsr_destination_street'] = $form_data['destination_street'];
		} else {
			$data['shipping_baikalsr_destination_street'] = $order_info['shipping_address_1'] . ' ' . $order_info['shipping_address_2'];
		}
		if (isset($form_data['destination_house_guid'])) {
			$data['shipping_baikalsr_destination_house_guid'] = $form_data['destination_house_guid'];
		} else {
			$data['shipping_baikalsr_destination_house_guid'] = '';
		}
		if (isset($form_data['destination_house'])) {
			$data['shipping_baikalsr_destination_house'] = $form_data['destination_house'];
		} else {
			$data['shipping_baikalsr_destination_house'] = '';
		}
		if (isset($form_data['destination_housing'])) {
			$data['shipping_baikalsr_destination_housing'] = $form_data['destination_housing'];
		} else {
			$data['shipping_baikalsr_destination_housing'] = '';
		}
		if (isset($form_data['destination_building'])) {
			$data['shipping_baikalsr_destination_building'] = $form_data['destination_building'];
		} else {
			$data['shipping_baikalsr_destination_building'] = '';
		}
		if (isset($form_data['destination_apartment'])) {
			$data['shipping_baikalsr_destination_apartment'] = $form_data['destination_apartment'];
		} else {
			$data['shipping_baikalsr_destination_apartment'] = '';
		}
		if (isset($form_data['destination_comment'])) {
			$data['shipping_baikalsr_destination_comment'] = $form_data['destination_comment'];
		} else {
			if($order_info['shipping_code']=='baikalsr.baikalsr')			
				$data['shipping_baikalsr_destination_comment'] = $order_info['shipping_city'] . ' ' . $order_info['shipping_zone'] . ' ' . $order_info['shipping_address_1'] . ' ' . $order_info['shipping_address_2'];
			else
				$data['shipping_baikalsr_destination_comment'] = '';
		}
		if (isset($form_data['destination_prr'])) {
			$data['shipping_baikalsr_destination_prr'] = $form_data['destination_prr'];
		} else {
			$data['shipping_baikalsr_destination_prr'] = false;
		}
		if (isset($form_data['destination_floor'])) {
			$data['shipping_baikalsr_destination_floor'] = $form_data['destination_floor'];
		} else {
			$data['shipping_baikalsr_destination_floor'] = '';
		}
		if (isset($form_data['destination_lift'])) {
			$data['shipping_baikalsr_destination_lift'] = $form_data['destination_lift'];
		} else {
			$data['shipping_baikalsr_destination_lift'] = true;
		}
		$data['cargo_types'] = $this->baikalsrtools->getCargoTypes();	
		if (isset($form_data['cargotype_id'])) {
			$data['shipping_baikalsr_cargotype_id'] = $form_data['cargotype_id'];
		} else {
			$data['shipping_baikalsr_cargotype_id'] = $this->config->get('shipping_baikalsr_cargotype_id');
		}		
		if (isset($form_data['packing'])) {
			$data['shipping_baikalsr_packing'] = $form_data['packing'];
		} else {
			$data['shipping_baikalsr_packing'] = $this->config->get('shipping_baikalsr_packing');
		}	
	
		// Products
		$data['products'] = array();
		$products = $this->model_sale_order->getOrderProducts($order_id);
	
		// Uploaded files
		$this->load->model('tool/upload');
		
		$defaultForItem = $this->config->get('shipping_baikalsr_default_for_item');
		$defLength = $this->baikalsrtools->convertLength($this->config->get('shipping_baikalsr_length'), $this->config->get('shipping_baikalsr_length_class_id'));
		$defWidth = $this->baikalsrtools->convertLength($this->config->get('shipping_baikalsr_width'), $this->config->get('shipping_baikalsr_length_class_id'));
		$defHeight = $this->baikalsrtools->convertLength($this->config->get('shipping_baikalsr_height'), $this->config->get('shipping_baikalsr_length_class_id'));
		$defWeight = $this->baikalsrtools->convertWeight($this->config->get('shipping_baikalsr_weight'), $this->config->get('shipping_baikalsr_weight_class_id'));
        $totalVolume1 = 0;
		$totalWeight1 = 0;
        $totalVolume2 = 0;
		$totalWeight2 = 0;
        $maxLength = 0;
        $maxWidth = 0;
        $maxHeight = 0;
		foreach ($products as $product) {
			$product_info = $this->model_catalog_product->getProduct($product['product_id']);
			
			$option_data = array();

			$options = $this->model_sale_order->getOrderOptions($order_id, $product['order_product_id']);

			foreach ($options as $option) {
				if ($option['type'] != 'file') {
					$option_data[] = array(
						'name'  => $option['name'],
						'value' => $option['value'],
						'type'  => $option['type']
					);
				} else {
					$upload_info = $this->model_tool_upload->getUploadByCode($option['value']);

					if ($upload_info) {
						$option_data[] = array(
							'name'  => $option['name'],
							'value' => $upload_info['name'],
							'type'  => $option['type'],
							'href'  => $this->url->link('tool/upload/download', 'user_token=' . $this->session->data['user_token'] . '&code=' . $upload_info['code'], true)
						);
					}
				}
			}
			
			if(!empty((float) $product_info['weight']) && !empty($product_info['weight_class_id'])){
				$totalWeight1 += $product['quantity'] * $this->baikalsrtools->convertWeight($product_info['weight'], $product_info['weight_class_id']);	
			}else{
				if($defaultForItem)
					$totalWeight2 += $product['quantity'] * $defWeight;
				else
					$totalWeight2 = $defWeight;
			}
			if(!empty((float) $product_info['length']) && !empty((float) $product_info['width']) && !empty((float) $product_info['height']) && !empty($product_info['length_class_id'])){
				$length = $this->baikalsrtools->convertLength($product_info['length'], $product_info['length_class_id']);
				$width = $this->baikalsrtools->convertLength($product_info['width'], $product_info['length_class_id']);
				$height = $this->baikalsrtools->convertLength($product_info['height'], $product_info['length_class_id']);
				$totalVolume1 += $product['quantity'] * $length * $width * $height;
			}else{
				$length = $defLength;
				$width = $defWidth;
				$height = $defHeight;
				if($defaultForItem)
					$totalVolume2 += $product['quantity'] * $defLength * $defWidth * $defHeight;
				else
					$totalVolume2 = $defLength * $defWidth * $defHeight;
			}
			if($length > $maxLength) $maxLength = $length;
			if($width > $maxWidth) $maxWidth = $width;
			if($height > $maxHeight) $maxHeight = $height;
			
			$data['products'][] = array(
				'order_product_id' => $product['order_product_id'],
				'product_id'       => $product['product_id'],
				'name'    	 	   => $product_info['name'],
				'model'    		   => $product_info['model'],
				'option'   		   => $option_data,
				'length'   		   => $product_info['length'],
				'width'   		   => $product_info['width'],
				'height'   		   => $product_info['height'],
				'length_class_id'  => $product_info['length_class_id'],
				'weight'		   => $product_info['weight'],
				'weight_class_id'  => $product_info['weight_class_id'],
				'quantity'		   => $product['quantity'],
				'price'    		   => $this->currency->format($product['price'] + ($this->config->get('config_tax') ? $product['tax'] : 0), $order_info['currency_code'], $order_info['currency_value']),
				'total'    		   => $this->currency->format($product['total'] + ($this->config->get('config_tax') ? ($product['tax'] * $product['quantity']) : 0), $order_info['currency_code'], $order_info['currency_value']),
				'href'     		   => $this->url->link('catalog/product/edit', 'user_token=' . $this->session->data['user_token'] . '&product_id=' . $product['product_id'], true)
			);
		}

		// Vouchers
		$data['vouchers'] = array();

		$vouchers = $this->model_sale_order->getOrderVouchers($order_id);

		foreach ($vouchers as $voucher) {
			$data['vouchers'][] = array(
				'description' => $voucher['description'],
				'amount'      => $this->currency->format($voucher['amount'], $order_info['currency_code'], $order_info['currency_value']),
				'href'        => $this->url->link('sale/voucher/edit', 'user_token=' . $this->session->data['user_token'] . '&voucher_id=' . $voucher['voucher_id'], true)
			);
		}

		$data['totals'] = array();

		$totals = $this->model_sale_order->getOrderTotals($order_id);		
		$estimated_cost = 0;
		$shipping_cost = 0;
		foreach ($totals as $total) {
			$total_line = array(
				'title' => $total['title'],
				'text'  => $this->currency->format($total['value'], $order_info['currency_code'], $order_info['currency_value'])
			);
			if ($total['code'] == 'sub_total') {
				$estimated_cost = $estimated_cost + $total['value'];
			}
			if ($total['code'] == 'tax') {
				$estimated_cost = $estimated_cost + $total['value'];
			}
			if ($total['code'] == 'shipping') {
				if (isset($shipment['shipping_cost']) && $shipment['shipping_cost'] != $total['value']) {
					$total_line['new_text'] = $this->currency->format($shipment['shipping_cost'], $order_info['currency_code'], $order_info['currency_value']);
				}
				$shipping_cost = $total['value'];
			}
			$data['totals'][$total['code']] = $total_line;
		}
		
		if (isset($form_data['volume'])) {
			$data['shipping_baikalsr_volume'] = $form_data['volume'];
		} else {
			$data['shipping_baikalsr_volume'] = $totalVolume1 + $totalVolume2;
		}	
		if (isset($form_data['weight'])) {
			$data['shipping_baikalsr_weight'] = $form_data['weight'];
		} else {
			$data['shipping_baikalsr_weight'] = $totalWeight1 + $totalWeight2;
		}	
		if (isset($form_data['length'])) {
			$data['shipping_baikalsr_length'] = $form_data['length'];
		} else {
			$data['shipping_baikalsr_length'] = $maxLength;
		}	
		if (isset($form_data['width'])) {
			$data['shipping_baikalsr_width'] = $form_data['width'];
		} else {
			$data['shipping_baikalsr_width'] = $maxWidth;
		}	
		if (isset($form_data['height'])) {
			$data['shipping_baikalsr_height'] = $form_data['height'];
		} else {
			$data['shipping_baikalsr_height'] = $maxHeight;
		}	
		if (isset($form_data['estimated_cost'])) {
			$data['shipping_baikalsr_estimated_cost'] = $form_data['estimated_cost'];
		} else {
			$data['shipping_baikalsr_estimated_cost'] = $estimated_cost;
		}			

		$json['body'] = $this->load->view('extension/shipping/baikalsr_popup_shipping', $data);
	} else {
		$json['title'] = $this->language->get('error_popup_not_found_title');
		$json['body'] = $this->language->get('error_popup_not_found_body');
	}

	$this->response->addHeader('Content-Type: application/json');
	$this->response->setOutput(json_encode($json));
}	

protected function prepareData($data) {
	$new_data = [];
	foreach ( $data as $key => $value )
	{
		$new_data[str_replace('shipping_baikalsr_', '', $key)] = $value;
	}
	return $new_data;
}

protected function validateForm($form_data) {
	//if (!$this->user->hasPermission('modify', 'extension/advertise/google')) {
	//	$this->error['warning'] = $this->language->get('error_permission');
	//}
	if (empty($this->error)) {
		if(!isset($form_data['consignor_contragent_id']) || $form_data['consignor_contragent_id'] == ''
			|| $form_data['consignor_contragent_id'] == '-1')
			$this->error['consignor_contragent'] = $this->language->get('error_no_contragent');
		if(!isset($form_data['consignor_fio']) || $form_data['consignor_fio'] == '')
			$this->error['consignor_fio'] = $this->language->get('error_no_fio');
		if(!isset($form_data['author_firstname']) || $form_data['author_firstname'] == '')
			$this->error['consignor_fio'] = $this->language->get('error_no_fio');
		if(!isset($form_data['author_middlename']) || $form_data['author_middlename'] == '')
			$this->error['consignor_fio'] = $this->language->get('error_no_fio');
		if(!isset($form_data['author_lastname']) || $form_data['author_lastname'] == '')
			$this->error['consignor_fio'] = $this->language->get('error_no_fio');
		if(!isset($form_data['consignor_phone']) || $form_data['consignor_phone'] == '')
			$this->error['consignor_phone'] = $this->language->get('error_no_phone');
		elseif(strlen(preg_replace('![^0-9]+!', '', $form_data['consignor_phone'])) < 11)
			$this->error['consignor_phone'] = $this->language->get('error_not_correct_phone');
		if(!isset($form_data['consignor_email']) || $form_data['consignor_email'] == '')
			$this->error['consignor_email'] = $this->language->get('error_no_email');
		if(isset($form_data['consignee_physical_person']) && $form_data['consignee_physical_person'] != '1'){
			if(!isset($form_data['consignee_company']) || $form_data['consignee_company'] == '')
				$this->error['consignee_company'] = $this->language->get('error_no_company_name');
			if(!isset($form_data['consignee_legal_opf_id']) || $form_data['consignee_legal_opf_id'] == '' 
				|| $form_data['consignee_legal_opf_id'] == '-1')
				$this->error['consignee_legal_opf'] = $this->language->get('error_no_opf');
			if(!isset($form_data['consignee_inn_kpp']) || $form_data['consignee_inn_kpp'] == '')
				$this->error['consignee_inn_kpp'] = $this->language->get('error_no_inn_kpp');			
		}
		if(!isset($form_data['consignee_fio']) || $form_data['consignee_fio'] == '')
			$this->error['consignee_fio'] = $this->language->get('error_no_fio');			
		if(isset($form_data['consignee_physical_person']) && $form_data['consignee_physical_person'] == '1'){
			if(isset($form_data['consignee_no_document']) && $form_data['consignee_no_document'] != '1'){
				if(!isset($form_data['consignee_physical_document_id']) || $form_data['consignee_physical_document_id'] == '' 
					|| $form_data['consignee_physical_document_id'] == '-1')
					$this->error['consignee_physical_document'] = $this->language->get('error_no_document');	
				if(!isset($form_data['consignee_seria_number']) || $form_data['consignee_seria_number'] == '')
					$this->error['consignee_seria_number'] = $this->language->get('error_no_seria_number');		
			}
		}
		if(!isset($form_data['consignee_phone']) || $form_data['consignee_phone'] == '')
			$this->error['consignee_phone'] = $this->language->get('error_no_phone');
		elseif(strlen(preg_replace('![^0-9]+!', '', $form_data['consignee_phone'])) < 11)
			$this->error['consignee_phone'] = $this->language->get('error_not_correct_phone');
		if(!isset($form_data['consignee_email']) || $form_data['consignee_email'] == '')
			$this->error['consignee_email'] = $this->language->get('error_no_email');
		if(!isset($form_data['departure_guid']) || $form_data['departure_guid'] == '')
			$this->error['departure'] = $this->language->get('error_no_departure');
		if(!isset($form_data['departure']) || $form_data['departure'] == '')
			$this->error['departure'] = $this->language->get('error_no_departure');
		if(isset($form_data['departure_from_address']) && $form_data['departure_from_address'] != '1'){
			if(!isset($form_data['departure_terminal_id']) || $form_data['departure_terminal_id'] == '' 
				|| $form_data['departure_terminal_id'] == '-1')
				$this->error['departure_terminal'] = $this->language->get('error_no_terminal');					
		}	
		if(isset($form_data['departure_from_address']) && $form_data['departure_from_address'] == '1'){
			if(!isset($form_data['departure_street_guid']) || $form_data['departure_street_guid'] == '')
				$this->error['departure_street'] = $this->language->get('error_no_street');		
			if(!isset($form_data['departure_street']) || $form_data['departure_street'] == '')
				$this->error['departure_street'] = $this->language->get('error_no_street');		
			if(!isset($form_data['departure_house_guid']) || $form_data['departure_house_guid'] == '')
				$this->error['departure_house'] = $this->language->get('error_no_house');		
			if(!isset($form_data['departure_house']) || $form_data['departure_house'] == '')
				$this->error['departure_house'] = $this->language->get('error_no_house');	
			if(isset($form_data['departure_prr']) && $form_data['departure_prr'] == '1'){
				if(!isset($form_data['departure_floor']) || $form_data['departure_floor'] == '')
					$this->error['departure_floor'] = $this->language->get('error_no_floor');	
			}
		}	
		if(!isset($form_data['destination_guid']) || $form_data['destination_guid'] == '')
			$this->error['destination'] = $this->language->get('error_no_destination');
		if(!isset($form_data['destination']) || $form_data['destination'] == '')
			$this->error['destination'] = $this->language->get('error_no_destination');
		if(isset($form_data['destination_to_address']) && $form_data['destination_to_address'] != '1'){
			if(!isset($form_data['destination_terminal_id']) || $form_data['destination_terminal_id'] == '' 
				|| $form_data['destination_terminal_id'] == '-1')
				$this->error['destination_terminal'] = $this->language->get('error_no_terminal');					
		}			
		if(isset($form_data['destination_to_address']) && $form_data['destination_to_address'] == '1'){
			if(!isset($form_data['destination_street_guid']) || $form_data['destination_street_guid'] == '')
				$this->error['destination_street'] = $this->language->get('error_no_street');		
			if(!isset($form_data['destination_street']) || $form_data['destination_street'] == '')
				$this->error['destination_street'] = $this->language->get('error_no_street');		
			if(!isset($form_data['destination_house_guid']) || $form_data['destination_house_guid'] == '')
				$this->error['destination_house'] = $this->language->get('error_no_house');		
			if(!isset($form_data['destination_house']) || $form_data['destination_house'] == '')
				$this->error['destination_house'] = $this->language->get('error_no_house');	
			if(isset($form_data['destination_prr']) && $form_data['destination_prr'] == '1'){
				if(!isset($form_data['destination_floor']) || $form_data['destination_floor'] == '')
					$this->error['destination_floor'] = $this->language->get('error_no_floor');	
			}
		}	
		if(!isset($form_data['cargotype_id']) || $form_data['cargotype_id'] == '' 
			|| $form_data['cargotype_id'] == '-1')
			$this->error['cargotype'] = $this->language->get('error_no_cargotype');			
		if(!isset($form_data['volume']) || $form_data['volume'] == '' 
			|| $form_data['volume'] == '0')
			$this->error['volume'] = $this->language->get('error_no_volume');		
		if(!isset($form_data['weight']) || $form_data['weight'] == '' 
			|| $form_data['weight'] == '0')
			$this->error['weight'] = $this->language->get('error_no_weight');					
	}

	if (!isset($this->error['warning']) && $this->error) {
		$this->error['warning'] = $this->language->get('error_warning');
	}

	return !$this->error;
}

public function fias_cities(){
	if (($this->request->server['REQUEST_METHOD'] != 'POST'))
		return;
	if(isset($this->request->post['text']) && !empty($this->request->post['text'])){
		$text = $this->request->post['text'];
		$apiKey = null;
		$apiTypeTest = null;	
		if(isset($this->request->post['apiKey']) && isset($this->request->post['apiTypeTest'])){
			$apiTypeTest = $this->request->post['apiTypeTest'];
			$apiKey = $this->request->post['apiKey'];
		}		
		$this->load->library('baikalsrtools');
		$arCities = $this->baikalsrtools->getCitiesByName($text, "", $apiKey, $apiTypeTest);
		echo json_encode($arCities);
	} else {
		echo json_encode(array());
	}
}

public function fias_streets(){
	if (($this->request->server['REQUEST_METHOD'] != 'POST'))
		return;
	if(isset($this->request->post['text']) && !empty($this->request->post['text'])
		 && isset($this->request->post['parent_guid']) && !empty($this->request->post['parent_guid'])){
		$text = $this->request->post['text'];
		$parent_guid = $this->request->post['parent_guid'];
		$apiKey = null;
		$apiTypeTest = null;	
		if(isset($this->request->post['apiKey']) && isset($this->request->post['apiTypeTest'])){
			$apiTypeTest = $this->request->post['apiTypeTest'];
			$apiKey = $this->request->post['apiKey'];
		}
		$this->load->library('baikalsrtools');
		$arStreets = $this->baikalsrtools->getStreetsByName($parent_guid, $text, $apiKey, $apiTypeTest);
		echo json_encode($arStreets);
	} else {
		echo json_encode(array());
	}
}

public function fias_houses(){
	if (($this->request->server['REQUEST_METHOD'] != 'POST'))
		return;
	if(isset($this->request->post['text']) && !empty($this->request->post['text'])
		 && isset($this->request->post['parent_guid']) && !empty($this->request->post['parent_guid'])){
		$text = $this->request->post['text'];
		$parent_guid = $this->request->post['parent_guid'];
		$apiKey = null;
		$apiTypeTest = null;	
		if(isset($this->request->post['apiKey']) && isset($this->request->post['apiTypeTest'])){
			$apiTypeTest = $this->request->post['apiTypeTest'];
			$apiKey = $this->request->post['apiKey'];
		}
		$this->load->library('baikalsrtools');
		$arHouses = $this->baikalsrtools->getHousesByName($parent_guid, $text, $apiKey, $apiTypeTest);
		echo json_encode($arHouses);
	} else {
		echo json_encode(array());
	}
}

public function cargoTypes_list(){
	if (($this->request->server['REQUEST_METHOD'] != 'POST'))
		return;
	$apiKey = null;
	$apiTypeTest = null;	
	if(isset($this->request->post['apiKey']) && isset($this->request->post['apiTypeTest'])){
		$apiTypeTest = $this->request->post['apiTypeTest'];
		$apiKey = $this->request->post['apiKey'];
	}
	$result = array('elements' => []);
	$this->load->library('baikalsrtools');
	$response = $this->baikalsrtools->getCargoTypes($apiKey, $apiTypeTest);
	if(isset($response['error']) && !empty($response['error'])){
		$result['error'] = $response['error'];
	}else{
		foreach($response as $data) {
			if(isset($data['id']) && isset($data['name']))
				$result['elements'][] = array('id' => $data['id'], 'name' => $data['name']);
		}
	}
	echo json_encode($result);
}

public function contragent_list(){
	if (($this->request->server['REQUEST_METHOD'] != 'POST'))
		return;
	$apiKey = null;
	$apiTypeTest = null;
	if(isset($this->request->post['apiKey']) && isset($this->request->post['apiTypeTest'])){
		$apiTypeTest = $this->request->post['apiTypeTest'];
		$apiKey = $this->request->post['apiKey'];
	}
	$result = array('elements' => []);
	$this->load->library('baikalsrtools');
	$response = $this->baikalsrtools->getContragents($apiKey, $apiTypeTest);
	if(isset($response['error']) && !empty($response['error'])){
		$result['error'] = $response['error'];
	}else{
		foreach($response as $data) {
			if(isset($data['guid']) && isset($data['name']))
				$result['elements'][] = array('id' => $data['guid'], 'name' => $data['name']);
		}
	}
	echo json_encode($result);
}

public function terminals_list(){
	if (($this->request->server['REQUEST_METHOD'] != 'POST'))
		return;
	if(isset($this->request->post['parent_guid']) && !empty($this->request->post['parent_guid'])){
		$parent_guid = $this->request->post['parent_guid'];
		if(isset($this->request->post['terminal_type']) && !empty($this->request->post['terminal_type']))
			$terminal_type = $this->request->post['terminal_type'];		
		else
			$terminal_type = 'start';
		$apiKey = null;
		$apiTypeTest = null;
		if(isset($this->request->post['apiKey']) && isset($this->request->post['apiTypeTest'])){
			$apiKey = $this->request->post['apiKey'];
			$apiTypeTest = $this->request->post['apiTypeTest'];
		}	
		$result = array('elements' => []);
		$this->load->library('baikalsrtools');
		$this->load->model('extension/shipping/baikalsr');
		$response = $this->baikalsrtools->getAffiliateData($parent_guid, $apiKey, $apiTypeTest);
		if(isset($response['error']) && !empty($response['error'])){
			$result['error'] = $response['error'];
		}else{
			if (isset($response["terminals"]) && !empty($response["terminals"])) {
				foreach($response["terminals"] as $terminal) {
					if(isset($terminal[$terminal_type]) && $terminal[$terminal_type]){
						$terminal["address"] = $this->baikalsrtools->htmlspecialcharsBack($terminal["address"]);
						$result['elements'][] = array('id' => $terminal['id'], 'name' => $terminal['name']." (".$terminal["address"].")");
					}
				}
			}
		}
		echo json_encode($result);
	} else {
		echo json_encode(array());
	}
}

}
?>